From d663edbf48bae474aff85f0510b4b0eccc68b6d3 Mon Sep 17 00:00:00 2001
From: Ralph Bean <rbean@redhat.com>
Date: Mar 29 2016 15:10:44 +0000
Subject: [PATCH 352/1001] Make the cobweb widget invalidate-able.


---

diff --git a/hubs/widgets/cobwebs.py b/hubs/widgets/cobwebs.py
index f03aa86..1b91407 100755
--- a/hubs/widgets/cobwebs.py
+++ b/hubs/widgets/cobwebs.py
@@ -1,33 +1,41 @@
-from hubs.hinting import hint, prefixed as _
-
-import arrow
-import datetime
+from hubs.hinting import hint
 
 from hubs.widgets import templating
 from hubs.widgets.chrome import panel
+
+import hubs.models
+
+
+def days_since(then):
+    return (datetime.datetime.utcnow() - then).days
+
 klass_switcher = lambda data: 'panel-danger' if data['archived'] else 'panel-info'
 chrome = panel(None, key='old', klass=klass_switcher)
+templating.environment.filters['days_since'] = days_since
 template = templating.environment.get_template('templates/cobwebs.html')
 
 
 def data(session, widget):
-    days = widget.hub.days_idle
+    last_modified = widget.hub.last_modified
     archived = widget.hub.archived
-    old = days > 31 or archived
-    then = datetime.datetime.utcnow() - datetime.timedelta(days=days)
-    then = arrow.get(then).humanize()
+
     import flask
     if archived:
         icon = flask.url_for('static', filename='img/archived.png')
     else:
         icon = flask.url_for('static', filename='img/cobweb.png')
-    return dict(old=old, days=days, then=then, icon=icon, archived=archived)
+
+    return dict(last_modified=last_modified, archived=archived, icon=icon)
 
 
-#@hint(topics=[_('hubs.widget.update')])
+@hint(ubiquitous=True)
 def should_invalidate(message, session, widget):
-    # TODO -- this one is going to be to be reorganized, since there's no event
-    # that causes this one to flip.
-    # We could add a hack that forces the deletion of this key when other
-    # widgets on the same hub are updated...  but that would be very special.
-    raise NotImplementedError()
+
+    # TODO -- return True if the message says that this hub is archived
+
+    hub = hubs.models.Hub.get(session, widget.hub_id)
+    others = [w for w in hub.widgets if w.plugin != 'cobwebs']
+    for other in others:
+        if should_invalidate(message, session, other):
+            return True
+    return False
